/* Autogenerated by mlir-tblgen; don't manually edit */
#ifdef GEN_PASS_CLASSES

//===----------------------------------------------------------------------===//
// ConsolidateAttributes
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class ConsolidateAttributesBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ConsolidateAttributesBase;

  ConsolidateAttributesBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConsolidateAttributesBase(const ConsolidateAttributesBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-consolidate-attrs");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-consolidate-attrs"; }

  ::llvm::StringRef getDescription() const override { return "Reify type data from attributes to types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConsolidateAttributes");
  }
  ::llvm::StringRef getName() const override { return "ConsolidateAttributes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
};

//===----------------------------------------------------------------------===//
// ControlFlowSink
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class ControlFlowSinkBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ControlFlowSinkBase;

  ControlFlowSinkBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ControlFlowSinkBase(const ControlFlowSinkBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-cf-sink");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-cf-sink"; }

  ::llvm::StringRef getDescription() const override { return "Perform control-flow sink on region-based control-flow ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ControlFlowSink");
  }
  ::llvm::StringRef getName() const override { return "ControlFlowSink"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
};

//===----------------------------------------------------------------------===//
// DedupeAndHoistConstant
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class DedupeAndHoistConstantBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = DedupeAndHoistConstantBase;

  DedupeAndHoistConstantBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  DedupeAndHoistConstantBase(const DedupeAndHoistConstantBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-dedupe-hoist-constant");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-dedupe-hoist-constant"; }

  ::llvm::StringRef getDescription() const override { return "Dedupe and hoist constants"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("DedupeAndHoistConstant");
  }
  ::llvm::StringRef getName() const override { return "DedupeAndHoistConstant"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
  ::mlir::Pass::Option<int64_t> max_size_{*this, "max-size", ::llvm::cl::desc("The maximum number of elements when considering whether a constant is small"), ::llvm::cl::init(10)};
  ::mlir::Pass::Option<bool> assume_strict_calls_{*this, "assume-strict-calls", ::llvm::cl::desc("Assume all function calls are stricts, that is operands are evaluated prior to the call"), ::llvm::cl::init(false)};
};

//===----------------------------------------------------------------------===//
// DropOutputShapesAttr
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class DropOutputShapesAttrBase : public ::mlir::OperationPass<> {
public:
  using Base = DropOutputShapesAttrBase;

  DropOutputShapesAttrBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  DropOutputShapesAttrBase(const DropOutputShapesAttrBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-drop-unregistered-output-shapes");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-drop-unregistered-output-shapes"; }

  ::llvm::StringRef getDescription() const override { return "Drop _output_shapes attribute"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("DropOutputShapesAttr");
  }
  ::llvm::StringRef getName() const override { return "DropOutputShapesAttr"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
  ::mlir::Pass::ListOption<std::string> skip_{*this, "skip", ::llvm::cl::desc("Comma separated list of ops that will be skipped."), llvm::cl::MiscFlags::CommaSeparated};
};

//===----------------------------------------------------------------------===//
// GraphToFunc
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class GraphToFuncBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = GraphToFuncBase;

  GraphToFuncBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  GraphToFuncBase(const GraphToFuncBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-lift-graph-to-func");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-lift-graph-to-func"; }

  ::llvm::StringRef getDescription() const override { return "Turns a graph into a function."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GraphToFunc");
  }
  ::llvm::StringRef getName() const override { return "GraphToFunc"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
  ::mlir::Pass::ListOption<std::string> feeds_{*this, "feeds", ::llvm::cl::desc("Comma separated list of ops that will be turned into arguments."), llvm::cl::MiscFlags::CommaSeparated};
  ::mlir::Pass::ListOption<std::string> fetches_{*this, "fetches", ::llvm::cl::desc("Comma separated list of ops that will be turned into results."), llvm::cl::MiscFlags::CommaSeparated};
  ::mlir::Pass::ListOption<std::string> control_rets_{*this, "control_rets", ::llvm::cl::desc("Comma separated list of ops that will be turned into control returned."), llvm::cl::MiscFlags::CommaSeparated};
};

//===----------------------------------------------------------------------===//
// PrepareAttributesForExport
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class PrepareAttributesForExportBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = PrepareAttributesForExportBase;

  PrepareAttributesForExportBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  PrepareAttributesForExportBase(const PrepareAttributesForExportBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-prepare-attrs-export");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-prepare-attrs-export"; }

  ::llvm::StringRef getDescription() const override { return "Legalize ops' attributes for export."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("PrepareAttributesForExport");
  }
  ::llvm::StringRef getName() const override { return "PrepareAttributesForExport"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
};

//===----------------------------------------------------------------------===//
// Remapper
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class RemapperBase : public ::mlir::OperationPass<> {
public:
  using Base = RemapperBase;

  RemapperBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  RemapperBase(const RemapperBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("remapper");
  }
  ::llvm::StringRef getArgument() const override { return "remapper"; }

  ::llvm::StringRef getDescription() const override { return "Remap operations to decrease amount of operations"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("Remapper");
  }
  ::llvm::StringRef getName() const override { return "Remapper"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
  ::mlir::Pass::Option<bool> enable_mkl_patterns_{*this, "enable-mkl-patterns", ::llvm::cl::desc("Enable the the MKL related patterns."), ::llvm::cl::init(false)};
};

//===----------------------------------------------------------------------===//
// TopoSort
//===----------------------------------------------------------------------===//

template <typename DerivedT>
class TopoSortBase : public ::mlir::OperationPass<> {
public:
  using Base = TopoSortBase;

  TopoSortBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  TopoSortBase(const TopoSortBase &other) : ::mlir::OperationPass<>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tfg-toposort");
  }
  ::llvm::StringRef getArgument() const override { return "tfg-toposort"; }

  ::llvm::StringRef getDescription() const override { return "Topologically sort graph and function regions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TopoSort");
  }
  ::llvm::StringRef getName() const override { return "TopoSort"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ConsolidateAttributes Registration
//===----------------------------------------------------------------------===//

inline void registerConsolidateAttributesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateConsolidateAttributesPass();
  });
}

//===----------------------------------------------------------------------===//
// ControlFlowSink Registration
//===----------------------------------------------------------------------===//

inline void registerControlFlowSinkPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateControlFlowSinkPass();
  });
}

//===----------------------------------------------------------------------===//
// DedupeAndHoistConstant Registration
//===----------------------------------------------------------------------===//

inline void registerDedupeAndHoistConstantPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateDedupeAndHoistConstantPass();
  });
}

//===----------------------------------------------------------------------===//
// DropOutputShapesAttr Registration
//===----------------------------------------------------------------------===//

inline void registerDropOutputShapesAttrPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateDropOutputShapesAttrPass();
  });
}

//===----------------------------------------------------------------------===//
// GraphToFunc Registration
//===----------------------------------------------------------------------===//

inline void registerGraphToFuncPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateGraphToFuncPass();
  });
}

//===----------------------------------------------------------------------===//
// PrepareAttributesForExport Registration
//===----------------------------------------------------------------------===//

inline void registerPrepareAttributesForExportPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreatePrepareAttributesForExportPass();
  });
}

//===----------------------------------------------------------------------===//
// Remapper Registration
//===----------------------------------------------------------------------===//

inline void registerRemapperPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateRemapperPass();
  });
}

//===----------------------------------------------------------------------===//
// TopoSort Registration
//===----------------------------------------------------------------------===//

inline void registerTopoSortPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return CreateTopoSortPass();
  });
}

//===----------------------------------------------------------------------===//
// TFGraph Registration
//===----------------------------------------------------------------------===//

inline void registerTFGraphPasses() {
  registerConsolidateAttributesPass();
  registerControlFlowSinkPass();
  registerDedupeAndHoistConstantPass();
  registerDropOutputShapesAttrPass();
  registerGraphToFuncPass();
  registerPrepareAttributesForExportPass();
  registerRemapperPass();
  registerTopoSortPass();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
